/**************************************************************************\
*
* Copyright (c)  Ųʽ. All Rights Reserved.
*
* Ųʽ - ٷվ : http://www.xcgui.com
*
\**************************************************************************/
#include "stdafx.h"

HWINDOW hWindow=NULL;
HELE hPane1=NULL;
HELE hPane2=NULL;
HELE hPane3=NULL;
HELE hPane4=NULL;

//²˵״̬
void CALLBACK OnMenu_UpdateUI(HMENUX hMenu,int id)
{
	XTRACE("OnMenu_UpdateUI() id=%d \n",id);

	HELE hPaneCur=NULL;
	switch(id)
	{
	case 301: hPaneCur=hPane1; break;
	case 302: hPaneCur=hPane2; break;
	case 303: hPaneCur=hPane3;break;
	case 304: hPaneCur=hPane4; break;
	default: return ;
	}

	if(NULL==hPaneCur) return ;
	pane_state_ state=XPane_GetState(hPaneCur);
	switch(state)
	{
	case pane_state_lock:
		XMenu_SetItemCheck(hMenu,id,TRUE);
		break;
	case pane_state_dock:
		XMenu_SetItemCheck(hMenu,id,FALSE);
		break;
	case pane_state_hide:
		XMenu_SetItemCheck(hMenu,id,FALSE);
		break;
	case pane_state_float:
		{
			HWINDOW hFloatWnd=XEle_GetHWindow(hPaneCur);
			if(hFloatWnd && XC_FLOATWND==XC_GetObjectType(hFloatWnd))
			{
				if(IsWindowVisible(XEle_GetHWnd(hPaneCur)))
					XMenu_SetItemCheck(hMenu,id,TRUE);
				else
					XMenu_SetItemCheck(hMenu,id,FALSE);
			}
		}break;
	}
	return ;
}

//˵ѡ¼,ʾش
BOOL CALLBACK OnEventMenuSelect(HELE hEle,HELE hEventEle,int id)
{
	if(hEle!=hEventEle)
		return FALSE;

	if(302==id)
	{
		XPane_Destroy(hPane2);
		XFrameWnd_AdjustLayout(hWindow);
		XWnd_ReDrawWnd(hWindow);
		return FALSE;
	}
	HELE hPaneCur=NULL;
	switch(id)
	{
	case 301: hPaneCur=hPane1; break;
	case 302: hPaneCur=hPane2; break;
	case 303: hPaneCur=hPane3;break;
	case 304: hPaneCur=hPane4; break;
	default: return FALSE;
	}
	if(NULL==hPaneCur) return FALSE;

	HMENUX hMenu=XMenuBar_GetMenu(hEle,2);

	pane_state_ state=XPane_GetState(hPaneCur);
	switch(state)
	{
	case pane_state_lock:
		XPane_Hide(hPaneCur);
		break;
	case pane_state_dock:
		XPane_popup(hPaneCur);
		break;
	case pane_state_hide:
		XPane_Show(hPaneCur);
		break;
	case pane_state_float:
		{
			HWINDOW hFloatWnd=XEle_GetHWindow(hPaneCur);
			if(hFloatWnd && XC_FLOATWND==XC_GetObjectType(hFloatWnd))
			{
				HWND hWnd=XEle_GetHWnd(hPaneCur);
				if(IsWindowVisible(hWnd))
					XWnd_ShowWindow(hFloatWnd,SW_HIDE);
				else
					XWnd_ShowWindow(hFloatWnd,SW_SHOW);
			}
		}break;
	}
	XFrameWnd_AdjustLayout(XEle_GetHWindow(hEle));
	XWnd_ReDrawWnd(hWindow);

	return FALSE;
}

int APIENTRY _tWinMain(HINSTANCE hInstance,  HINSTANCE hPrevInstance, LPTSTR lpCmdLine, int nCmdShow)
{
	XInitXCGUI();

	//
	hWindow=XFrameWnd_CreateWindow(0,0,600,500,L"Ųʽ-ܴ");

	HELE hMenuBar=XMenuBar_Create(10,10,300,26,hWindow);
	XMenuBar_AddButton(hMenuBar,L"ͼ");

	//ӵ˵
	XMenuBar_AddMenuItem(hMenuBar,0,301,L"ͼ-1");
	XMenuBar_AddMenuItem(hMenuBar,0,302,L"ͼ-2");
	XMenuBar_AddMenuItem(hMenuBar,0,303,L"ͼ-3");
	XMenuBar_AddMenuItem(hMenuBar,0,304,L"ͼ-4");

	HMENUX hMenux=XMenuBar_GetMenu(hMenuBar,0);
	XMenu_SetUserUpdateUI(hMenux,OnMenu_UpdateUI); //²˵״̬

	//
	hPane1=XPane_Create(L"1",hWindow);
	hPane2=XPane_Create(L"2",hWindow);
	hPane3=XPane_Create(L"3",hWindow);
 	hPane4=XPane_Create(L"3",hWindow);

	XFrameWnd_AddPane(hWindow,NULL,hPane1,align_any);        //ӴhPane1ܴ
	XFrameWnd_AddPane(hWindow,hPane1,hPane4,align_right,50); //ӴҲ

	HPANE_GROUP hGroup=XFrameWnd_MergePane(hWindow,hPane1,hPane2); //´hPane2ϲΪ
	XFrameWnd_MergePaneToGroup(hWindow,hGroup,hPane3);             //´hPane3ϲ

	HELE hEleView=XEle_Create(0,0,100,100,hPane1);
	XEle_SetBkColor(hEleView,RGB(255,0,0));
	XEle_EnableBorder(hEleView,FALSE);
	XPane_SetView(hPane1,hEleView); //ΪhPane1ͼ

	XPane_SetFixedSize(hPane4,TRUE); //̶4С

	XEle_RegisterEvent(hMenuBar,XE_MENUSELECT,OnEventMenuSelect);

	XFrameWnd_AdjustLayout(hWindow); //ܴڲ
	XWnd_ShowWindow(hWindow,SW_SHOW);

	XRunXCGUI();
	return 0;
}
